/// <reference types="amqplib" />
import Rabbit from './rabbit';
import * as amqp from 'amqplib';
import Queue from './queue';
declare abstract class BaseQueueHandler {
    queueName: any;
    rabbit: Rabbit;
    dlqName: string;
    queue: Queue;
    dlq: Queue;
    retries: number;
    retryDelay: number;
    logger: any;
    logEnabled: boolean;
    constructor(queueName: any, rabbit: Rabbit, {retries, retryDelay, logger, logEnabled}?: {
        retries?: number;
        retryDelay?: number;
        logger?: any;
        logEnabled?: boolean;
    });
    getDlq(): string;
    getCorrelationId(msg: amqp.Message, event?: any): any;
    getQueueOptions(): {};
    getDlqOptions(): any;
    init(): void;
    tryHandle(retries: any, msg: amqp.Message, ack: (reply) => any): Promise<void>;
    handleError(err: any, msg: any): void;
    getTime(): number;
    logTime(startTime: number, correlationId: string): void;
    setTimeout(time: any): Promise<{}>;
    retry(retries: any, msg: any, ack: any): Promise<void>;
    abstract handle(data: {
        msg: amqp.Message;
        event: any;
        correlationId: string;
        startTime: number;
    }): any;
    abstract afterDlq(data: {
        msg: amqp.Message;
        event: any;
    }): any;
    addToDLQ(retries: any, msg: amqp.Message, ack: any): Promise<void>;
}
export default BaseQueueHandler;
